<!doctype html>
<html lang="en">
  <head>
    <title>MPC20-v2</title>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <script src="/conf/config.js"></script>
    <style>
      .hidden {
        display: none;
      }

      body > .pure-g {
        max-width: 1200px;
        width: 1200px;
        margin: auto;
      }

      div {
        margin-bottom: 5px;
      }

      .loader {
        border: 4px solid #f3f3f3; /* Light grey */
        border-top: 4px solid #3498db; /* Blue */
        border-radius: 50%;
        width: 20px;
        height: 20px;
        animation: spin 2s linear infinite;
      }

      .input-address {
        width: 56ex;
        font-family: monospace;
      }

      .address {
        font-family: monospace;
        font-size: 1.3em;
      }

      @keyframes spin {
        0% {
          transform: rotate(0deg);
        }
        100% {
          transform: rotate(360deg);
        }
      }
    </style>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/purecss@3.0.0/build/pure-min.css"
      integrity="sha384-X38yfunGUhNzHpBaEBsWLO+A0HDYOQi8ufWDkZ0k9e0eXz/tH3II7uKZ9msv++Ls"
      crossorigin="anonymous" />
  </head>

  <body>
    <div class="pure-g">
      <div class="pure-u-1-1">
        <h1><span class="mode"></span> example application</h1>
        <div>
          <h2>Account</h2>
          <p>
            <span id="connection-status">Currently not logged in</span>
            <a id="connection-link" target="_blank" class="address"></a>
          </p>
          <div>
            <form class="pure-form" onSubmit="return false;">
              <input
                class="pure-button pure-button-primary hidden"
                id="connection-link-ledger-validate"
                type="submit"
                value="Verify on Ledger" />
            </form>
          </div>

          <div id="private-key-connect">
            <form class="pure-form" onSubmit="return false;">
              <input
                class="pure-button pure-button-primary"
                id="private-key-connect-btn"
                type="submit"
                value="Login using private key" />
              <input id="private-key-value" name="private-key-value" type="password" maxlength="" />
            </form>
          </div>

          <div id="wallet-connect">
            <form>
              <input
                class="pure-button pure-button-primary"
                id="wallet-connect-btn"
                type="button"
                value="Login using MPC Wallet" />
            </form>
          </div>

          <div id="metamask-connect">
            <form>
              <input
                class="pure-button pure-button-primary"
                id="metamask-connect-btn"
                type="button"
                value="Login using MetaMask snap" />
            </form>
          </div>

          <div id="ledger-connect">
            <form>
              <input
                class="pure-button pure-button-primary"
                id="ledger-connect-btn"
                type="button"
                value="Login using PBC Ledger App" />
            </form>
          </div>

          <div id="wallet-disconnect" class="hidden">
            <form>
              <input
                class="pure-button pure-button-primary"
                id="wallet-disconnect-btn"
                type="button"
                value="Logout" />
            </form>
          </div>
        </div>

        <h2>
          <span class="mode"></span> Address:
          <a id="current-address" target="_blank" class="address">None</a>
        </h2>
        <div id="address">
          <form class="pure-form" onSubmit="return false;">
            <input
              id="address-value"
              class="input-address address"
              name="address-value"
              type="text"
              minlength="42"
              maxlength="42" />
            <input
              class="pure-button pure-button-primary"
              id="address-btn"
              type="submit"
              value="Set contract" />
          </form>
        </div>
        <br />

        <div id="contract-interaction" class="hidden">
          <h2>Transfer</h2>
          <form class="pure-form" name="transfer-action-form" onSubmit="return false;">
            <input id="address-to" name="address-to" type="text" minlength="42" maxlength="42" />
            <input id="amount" name="amount" type="number" min="0" />
            <input
              class="pure-button pure-button-primary"
              id="transfer-btn"
              type="submit"
              value="Transfer" />
          </form>
          <div id="sign-transaction-link"></div>
          <div id="sign-transaction-error"></div>
        </div>

        <div id="contract-state" class="hidden">
          <h2 id="state-header"><span class="mode"></span> State</h2>
          <div id="update-state">
            <form>
              <input
                class="pure-button pure-button-primary"
                id="update-state-btn"
                type="button"
                value="Refresh State" />
              <input id="refresh-loader" class="loader hidden" />
            </form>
          </div>

          <table>
            <tr>
              <th>Name</th>
              <td id="name"></td>
            </tr>
            <tr>
              <th>Symbol</th>
              <td id="symbol"></td>
            </tr>
            <tr>
              <th>Decimals</th>
              <td id="decimals"></td>
            </tr>
            <tr>
              <th>Total Supply</th>
              <td id="total-supply"></td>
            </tr>
            <tr>
              <th>Owner</th>
              <td id="owner" class="address"></td>
            </tr>
          </table>
          <h2>Balances</h2>
          <form
            class="pure-form"
            name="transfer-action-form"
            onSubmit="return false;"
            id="get-balance-form">
            <input
              id="get-balance-address"
              name="get-balance-address"
              class="input-address address"
              type="text"
              minlength="42"
              maxlength="42" />
            <input
              class="pure-button pure-button-primary"
              id="get-balance-btn"
              type="submit"
              value="Get Balance" />
          </form>
          <div id="balance-value"></div>
          <h3>All balances</h3>
          <ul id="all-balances"></ul>
          <input
            class="pure-button pure-button-primary"
            id="balances-load-more-btn"
            type="submit"
            value="Load More" />
        </div>
      </div>
    </div>
  </body>
</html>
